/* K575.h
 * internal header file for K575 module
 * not for users
 *
 * written by Matthias D. Tews
 *  
 */
 
#ifndef ___I___K575_h
#define ___I___K575_h

/* analog out module, type 1 */
void AOM1_SetVoltage(unsigned SLOT, unsigned CHANNEL, unsigned value);
void AOM1_Out(void);
void AOM1_Init(void);

/* digital input/output on motherboard */
void DIO_SelectOut(unsigned channel);
void DIO_SelectIn(unsigned channel);
void DIO_SetByte(unsigned channel, unsigned v);
unsigned DIO_GetByte(unsigned channel);
void DIO_SetBit(unsigned bit);
void DIO_UnsetBit(unsigned bit);
unsigned DIO_GetBit(unsigned bit);

/* Analog Input with AMM1A */
/* if gain is negative use bipolar conversion, dont if gain > 0 */
/* allowed values for gain: 1,2,5,10,100 (or -1, ...) */
/* allowed values for filter: 2 kHz or 100 kHz */
int AMM1A_EndOfConversion(void);
void AMM1A_Convert(int channel, int gain, int filter);
void AMM1A_ConvertDiff(int channel, int gain, int filter);
unsigned AMM1A_value(void);
void AMM1A_Init(void);

/* for dirty hacks this may be used in K575.device.c */
void SetByte(unsigned off, unsigned data);
unsigned GetByte(unsigned off);

/* Timer Control and Interrupt Control */
void	  CNT_SetCounter(unsigned counter,unsigned value);
unsigned  CNT_GetCounter(int counter);
void	  CNT_SetIrqLevel(int irq);
void	  CNT_EndOfInterrupt(void);
void	  CNT_Init(void);

#include <k575.h>
#endif
