CFLAGS = -O6 -Wall -D__LINUX__ -DLINUX -D__KERNEL__ -I . -I /usr/local/include -pipe
CFILES_K575 = K575.device.c K575.io.c

all: K575 k575lib.o vtest
	rm -f /dev/K575 
	rm -f /usr/local/lib/k575lib.o
	mknod /dev/K575 c 31 0
	chmod ugo+rw /dev/K575 
	chmod ugo-x /dev/K575
	cp K575 /usr/local/sbin
	chmod ugo-rwx /usr/local/sbin/K575
	cp k575lib.o /usr/local/lib
	chmod ugo-rwx /usr/local/lib/k575lib.o 
	chmod ugo+r /usr/local/lib/k575lib.o
	cp k575lib.h /usr/local/include
	cp k575.h /usr/local/include
	rmmod K575
	insmod /usr/local/sbin/K575

K575: main.c $(CFILES_K575)
	gcc -fsyntax-only $(CFLAGS) $(CFILES_K575) 
	indent $(CFILES_K575) >& /dev/null
	rm *.c~
	gcc $(CFLAGS) -c main.c -o K575 >& /dev/null

main.c: GenMain Makefile 
	GenMain $(CFILES_K575)
	indent main.c>/dev/null
	rm *.c~

k575lib.o: k575lib.c
	gcc -fsyntax-only $(CFLAGS) -U__KERNEL__ -c -o k575lib.o k575lib.c
	indent k575lib.c >& /dev/null
	rm *.c~
	gcc $(CFLAGS) -U__KERNEL__ -c -o k575lib.o k575lib.c

vtest: k575lib.o vtest.c
	gcc -pipe -Wall k575lib.o vtest.c -o $@
	indent vtest.c

clean:
	rm -f *~ k575lib.o K575 main.c vtest
	touch *.h *.c