/* k575.h
 * ioctl macros for K575 module use
 * for experienced users only
 *
 * writen by Matthias D. Tews
 * 
 */
 
#ifndef ___I___k575_h
#define ___I___k575_h

#define	K575_MAJOR	31	/* normally NOT important */

/* IOCTL-Macros */

#define K575_AOM1_SetVoltage	_IOR(K575_MAJOR, 1, unsigned)
#define K575_AOM1_Out		_IO(K575_MAJOR, 2)

#define K575_DIO_SelectOut	_IOR(K575_MAJOR, 3, unsigned)
#define K575_DIO_SelectIn	_IOR(K575_MAJOR, 4, unsigned)
#define K575_DIO_SetByte	_IOR(K575_MAJOR, 5, unsigned)
#define K575_DIO_GetByte	_IOR(K575_MAJOR, 6, unsigned)
#define K575_DIO_SetBit		_IOR(K575_MAJOR, 7, unsigned)
#define K575_DIO_UnsetBit	_IOR(K575_MAJOR, 8, unsigned)
#define K575_DIO_GetBit		_IOWR(K575_MAJOR, 9, unsigned)


typedef struct
{
	int channel, gain, filter;
} K575_ConvertStruct;

#define K575_AMM1A_Convert	_IOR(K575_MAJOR, 9 , K575_ConvertStruct)
#define K575_AMM1A_ConvertDiff  _IOR(K575_MAJOR, 10, K575_ConvertStruct)
#define K575_AMM1A_Value	_IOW(K575_MAJOR, 11, unsigned)
#define K575_AMM1A_Ready	_IOW(K575_MAJOR, 12, int)

#define K575_CNT_GetCounter	_IOWR(K575_MAJOR, 13, unsigned)
#define K575_CNT_SetCounter	_IOR(K575_MAJOR, 14, unsigned)
#define K575_CNT_InterruptMode  _IO(K575_MAJOR, 15)

/* the following are for ROOT only */
#define K575_POKE		_IOR(K575_MAJOR,80, unsigned)
#define K575_PEAK		_IOWR(K575_MAJOR,81, unsigned)

#endif
