/* k575lib.h
 * easy interface to K575-module
 * for all users
 *
 * written by Matthias D. Tews
 * 
 */
 
#ifndef ___I___k575lib_h
#define ___I___k575lib_h

#if 0
struct timeval; 	/* if user did not include sys/time.h */
void start (void); 
void period(struct timeval *time);
#endif

void K575_StartTimer(void);
long K575_Time_ms (void);

void K575_Write_mV (int channel, int voltage_mV);
int K575_Read_mV (int channel, int gain, int filter);


void K575_open(void);
void K575_close(void);

void K575_SelectOut(int channel);
void K575_SelectIn(int channel);
void K575_SetByte(int channel, unsigned v);
int  K575_GetByte(int channel);
void K575_SetBit(int bit);
void K575_UnsetBit(int bit);
int  K575_GetBit(int bit);

void K575_SetAnalog(int channel, unsigned voltage);
void K575_OutAnalog(void); 
void K575_WriteAnalog(int channel, unsigned voltage); 

/* allowed values for gain 1, 2, 5, 10, 20, 50, 100 */
/*			  -1,-2,-5,-10,-20,-50,-100 */
/* filter may be 2 or 100 kHz */
void K575_Convert(int channel, int gain, int filter);
void K575_ConvertDiff(int channel, int gain, int filter);
unsigned K575_IsConversionReady(void);
unsigned K575_GetConvertedValue(void);
unsigned K575_ReadAnalog(int channel, int gain, int filter);
unsigned K575_ReadAnalogDiff(int channel, int gain, int filter);

/* for dirty hacks, and allowed only for root */
unsigned K575_Peak(unsigned offset);
void     K575_Poke(unsigned offset, unsigned value);

unsigned K575_GetCounter(unsigned nr);
void     K575_SetCounter(unsigned nr, unsigned value);
void	 K575_SetInterruptMode(unsigned mode);
#endif
