 /* Praktikum:	Ansteuerung fuer den 4. Versuch */

#include <stdio.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <math.h>
#include <k575lib.h>
#include <unistd.h>  /* u.a. fuer den chdir - Befehl  */
#include <stdio.h>   /* fuer Standard-Ein-Ausgabe */


#define nmax 10000
#define nmaxekan 16


messung(int cy[], int y [][nmaxekan], int nekan, int i)

{

int l;
int j;
int h;
int sum_messwert;
int min_messwert;
int max_messwert;


 K575_StartTimer();
	    for (j=0; j < nekan; j++)
	    {
	     for (l=0; l<=13; l++) 
	      h = K575_Read_mV (cy[j], -1, 100);
	     sum_messwert = 0;
             min_messwert = h;
	     max_messwert = h;
	     for (l = 0; l <= 9; l++) 
	      {
		 h = K575_Read_mV (cy[j], -1, 100);  /* Mittelwertbildung */
		if (h < min_messwert)
		  min_messwert = h;
		if (h > max_messwert)
		  max_messwert = h;
		sum_messwert = sum_messwert + h;
	      }
	    y[i][j] = (sum_messwert - min_messwert - max_messwert)/(8);  

	    }

}

ausgabe(int cu[], double us, double usa)

{

int l;
	    
	for (l=0; l<=13; l++) 
	   K575_Write_mV (cu[0], (int) us ); 
	for (l=0; l<=13; l++) 
	   K575_Write_mV (cu[1], (int) usa ); 
}



void main ()
{
	unsigned 	i,j,l;
	char		k;
	char 		ein_name [20];
	char 		aus_name [20];
	int 		u;
	int		ua;
	int 		e;
	int 		ea;
	double 		us;
	double 		usa;
	double 		x [3];
	int 		y [nmax][nmaxekan]; 
	long		messd, abtper,nekan;
	int 		cu [2];
	int		cy [nmaxekan];
        FILE*		fp;
	char	   	path [20]; 
	int 		ewh;
	int		szh;
	int 		awh;
	int 		ewa;
	int 		awa;
	int 		sza; 

	 printf ("\n Anzahl der Analogeingabekanle : ");
	   scanf ("%d", &nekan);
	printf ("\n Anzahl der Eingabekanle = %d \n\n\n" ,nekan);


	for (j = 0; j < nekan; j++)
		{
		printf (" Kanal-Nr. fuer Analogeingabe : ");
		scanf ("%d", &cy[j]);
		printf ("\n Analogeingabekanal: %d\n\n\n", cy[j]);
		(cy[j]) --; 
		}

	cu[0]=0;
	cu[1]=1;

	for (j = 0; j < nmax; j++)
	   {
		for (i = 0; i < nekan; i++)
		y [j] [i] = 0;
	   }         

	fp = NULL;

	printf ("\n Abtastperiode [ms]: ");
	scanf ("%ld", &abtper);
	printf ("\n Abtastperiode = %ld ms \n\n\n" ,abtper );

	printf (" Messdauer [# Abtastperioden] : ");
	scanf ("%d", &messd);
	printf ("\n Messdauer = %d Abtastperioden\n\n\n", messd );

	printf (" \n \n \n Sollwert fr die Abflumenge : \n \n");
	printf (" Anfangswert (mV) : ");
	scanf ("%d", &awa);
	printf ("\n Anfangswert: %d \n \n", awa );
	printf (" Endwert (mV): ");
	scanf ("%d", &ewa);
	printf ("\n Endwert: %d \n \n", ewa );
	printf (" Sprungzeitpunkt (Abtastperioden) : ");
	scanf ("%d", &sza);
	printf ("\n Sprungzeitpunkt (Abtastperioden) : %d \n \n", sza );


	printf ("  \n \n \n Sollwert fr das Behlterniveau : \n \n");
	printf (" Anfangswert (mV) : ");
	scanf ("%d", &awh);
	printf ("\n Anfangswert (mV) : %d \n \n", awh );
	printf (" Endwert (mV) : ");
	scanf ("%d", &ewh);
	printf ("\n Endwert (mV) : %d \n \n", ewh );
	printf (" Sprungzeitpunkt (Abtastperioden) : ");
	scanf ("%d", &szh);
	printf ("\n Sprungzeitpunkt (Abtastperioden) : %d \n \n", szh );

	x[2] = awa;		/* Anfangswerte */
	x[1] = awh/3.5;
	x[0] = x[1]*(1-1.9556);


	printf("\n\n Return zum Starten der Messungen \n\n\n");
	getchar();
	getchar();

	K575_open();
	for (i=0; i< messd; i++)
	  {
	   messung(cy, y, nekan, i);

       	   usa = x[2];   /* Stellgre Abfluventil */

       	   us = x[1];   /* Stellgre Zufluventil */

	   ausgabe(cu, us, usa);
	    

	   /* Regelalgorithmus Abflumengenregelkreis */

	   if (i < sza)  	/* Sollwert Abflumenge ua */
		ua = awa;
 	   else
		ua = ewa;

	   ea = ua - y[i][1];	 /* Regeldifferenz Abflumenge */

   	   x[2] = x[2] + abtper*ea*3.58/10000;	/* Regelalgorithmus Abflumenge  */
	
	   if (x[2] < 0)		/* Anti-Reset-Windup Manahme */
		x[2] = 0;
	   else if (x[2] > 10000)
		x[2] = 10000;


	   /* Regelalgorithmus Niveauregelkreis */

	   if (i < szh) 	/* Sollwert Niveau u */
		u = awh;
 	   else
		u = ewh;

	   e = u - y[i][0];	 /* Regeldifferenz Hhe */	

   	   x[1] = x[0] + 1.9556*us + 0.0571*e;  	/* Regelalgorithmus Abflumenge  */        
	   x[0] = -0.9556*us - 0.057*e;

	   if (x[1] < 0)  	/* Anti-Reset-Windup Manahme */
 		x[1] = 0;  
 	   else if (x[1] > 3200)  
 		x[1] = 3200;  

	 printf (" %d : uh %d yh %d ua %d ya %d us %d  usa %d ", i, u, y[i][0], ua, y[i][1], (int) us, (int) usa ); 
         printf ("\n\n");

 	   while ( K575_Time_ms() < abtper);
	 K575_StartTimer();

	  }


	K575_Write_mV ( cu[0], 0 );

	K575_Write_mV ( cu[1], 0 );

	K575_close();

	printf ("\n\n");

	fp = NULL;
 	sprintf(path,"../matlab");
	chdir( path );  
	while ( fp == NULL )
	{  printf ("\n Ausgabedatei : ");
	   scanf ("%s", &aus_name);
	   printf ("\n");
	   fp = fopen (aus_name, "w");
	   if ( fp == NULL )
	       printf ("     Datei nicht geschrieben.\n");
	}
          for (i=0; i < messd; i++)  
             {   
	     fprintf (fp,"  %d  %d", i * abtper/1000, y[i][0]); 	    	     
	     printf (" %d : y %d ", i, y[i][0]);

	     for (j=1; j < nekan; j++)
	     {
	     fprintf (fp,"  %d ", y[i][j]); 
	     printf (" %d ", y[i][j] );
	     }
	    
	     printf ("\n ");
	     fprintf (fp,"\n"); 
              
 
	}
 	fprintf (fp,"\n"); 

	fclose (fp); 
        
	printf ("\n     Datei '%s' geschrieben. \n",aus_name);
            

}
